<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="会员ID" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入会员ID"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="订单ID" prop="id">
        <el-input
          v-model="queryParams.id"
          placeholder="请输入订单ID"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          :disabled="true"
          @click="openForm('create')"
          v-hasPermi="['member:task-record:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="会员ID" align="center" prop="userId" width="150px" />
      <el-table-column label="订单ID" align="center" prop="id" width="150px" />
      <el-table-column label="订单编号" align="center" prop="orderNo" width="250px" />
      <el-table-column label="数量" align="center" prop="quantity" width="150px" />
      <el-table-column label="商品ID" align="center" prop="productId" width="150px" />
      <el-table-column label="单价" align="center" prop="unitPrice" width="150px" />
      <el-table-column label="总价" align="center" prop="totalPrice" width="150px" />
      <el-table-column label="是否连单" align="center" prop="combination" width="150px">
        <template #default="{ row }">
          <dict-tag :type="DICT_TYPE.INFRA_YES_NO" :value="row.combination" />
        </template>
      </el-table-column>
      <el-table-column label="连单ID" align="center" prop="recordId" width="150px" />
      <el-table-column label="任务状态" align="center" prop="status" width="150px">
        <template #default="{ row }">
          <dict-tag :type="DICT_TYPE.TASK_EXECUTE_STATUS" :value="row.executeStatus" />
        </template>
      </el-table-column>
      <el-table-column
        label="完成时间"
        align="center"
        prop="submitTime"
        :formatter="dateFormatter"
        width="150px"
      />
      <el-table-column label="操作" align="center" width="150px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['member:task-record:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['member:task-record:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <TaskRecordForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts" name="TaskRecord">
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as TaskRecordApi from '@/api/member/taskRecord'
import TaskRecordForm from './TaskRecordForm.vue'

const { defaultUserId } = defineProps({
  defaultUserId: {
    type: Number
  }
})
const userId = ref(defaultUserId)

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  id: null,
  pageNo: 1,
  pageSize: 10,
  orderNo: null,
  userId: userId.value,
  quantity: null,
  productId: null,
  unitPrice: null,
  totalPrice: null,
  combination: null,
  status: null,
  submitTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await TaskRecordApi.getTaskRecordPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await TaskRecordApi.deleteTaskRecord(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}
/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await TaskRecordApi.exportTaskRecord(queryParams)
    download.excel(data, '任务记录.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
